class MovableDialog {
    constructor(title, contentRootElement, openButtonToDisableWhileVisible){
        this.window = document.createElement('div');
        this.window.addEventListener('click', function(){
            var overlays = document.querySelectorAll('#xpath-generation-movable-dialog');
            var topOverlayZindex = 0;
            for(var i = 0; i < overlays.length; i++){
                if(overlays[i].style.zIndex > topOverlayZindex && overlays[i].style.display != 'none') topOverlayZindex = overlays[i].style.zIndex;
            }
            this.window.style.zIndex = +topOverlayZindex + 1;
        }.bind(this), true);
        this.btn = openButtonToDisableWhileVisible;
        if(this.btn != null) this.btn.disabled = true;
        this.window.id = 'xpath-generation-movable-dialog';
        this.window.style = "-webkit-box-shadow: 10px 10px 11px 0px rgba(0,0,0,0.75);-moz-box-shadow: 10px 10px 11px 0px rgba(0,0,0,0.75);";
        this.window.style.boxShadow = "10px 10px 11px 0px rgba(0,0,0,0.75)"; 
        this.window.style.border = "4px solid #00005A";
        this.window.style.width = "400px";
        this.window.style.maxWidth = "45%";
        this.window.style.backgroundColor = "transparent";
        this.window.style.left = "10px";
        this.window.style.top = "40px";
        this.window.style.position = "fixed";
        this.window.style.zIndex = 15;

        var titlebar = document.createElement('div');
        titlebar.id = 'xpath-generator-dialog-titlebar';
        titlebar.style.backgroundColor = "#F1EEE7";
        titlebar.style.color = "#00005A";
        titlebar.style.width = "395px";
        titlebar.style.cursor = "move";
        titlebar.style.paddingLeft = "0.5rem";
        titlebar.style.textAlign = "left";
        titlebar.style.borderBottom =  "1px solid #00005A";
        titlebar.style.fontFamily = "Verdana, Geneva, Tahoma, sans-serif";
    
        this.titletext = document.createElement('span');
        this.titletext.style.left = '0px';
        this.titletext.innerHTML = title;
        titlebar.appendChild(this.titletext);
        var closeX = document.createElement('span');
        closeX.id = 'xpath-generator-close-overlay-X';
        closeX.style.backgroundColor = "crimson";
        closeX.style.color = "white";
        closeX.style.width = "15px";
        closeX.style.textAlign = "center";
        closeX.style.float = "right";
        closeX.style.borderLeft = "2px solid #00005A";
        closeX.style.bordeRight = "2px solid #00005A";
        closeX.style.cursor = "pointer";
        closeX.style.fontFamily = "Verdana, Geneva, Tahoma, sans-serif";
        closeX.innerHTML = 'X';
        closeX.addEventListener('click', function(){
            if(this.btn != null) this.btn.disabled = false;
            this.window.parentNode.removeChild(this.window);
        }.bind(this));
        titlebar.appendChild(closeX);
        this.window.appendChild(titlebar);
        /*
        this.content = document.createElement('div');
        this.content.style = 'border: 1px solid black; background-color: white; opacity: 0.5; overflow: auto;';
        this.content.appendChild(contentRootElement);
        this.window.appendChild(this.content);
        */
       this.window.appendChild(contentRootElement);
        this.window.style.display = "block";
        document.querySelector('body').appendChild(this.window);
        this.dragElement(this.window);
    }

    dragElement(elmnt) {
        var pos1 = 0, pos2 = 0, pos3 = 0, pos4 = 0, startX = 0, startY = 0;
        if(elmnt.classList.contains('non-draggable')) {
            elmnt.focus();
            return;
        }
        /*
        if (elmnt.querySelector('.movable-dialog .titlebar')) {
            // if present, the header is where you move the DIV from:
                elmnt.querySelector('.titlebar').onmousedown = dragMouseDown;
        } else {
            */
            // otherwise, move the DIV from anywhere inside the DIV:
            elmnt.onmousedown = dragMouseDown;
        //}

        function dragMouseDown(e) {
            e = e || window.event;
            e.preventDefault();
            // get the mouse cursor position at startup:
            pos3 = e.clientX;
            pos4 = e.clientY;
            startX = pos3;
            startY = pos4;
            document.onmouseup = closeDragElement;
            // call a function whenever the cursor moves:
            document.onmousemove = elementDrag;
        }

        function elementDrag(e) {
            e = e || window.event;
            e.preventDefault();
            // calculate the new cursor position:
            pos1 = pos3 - e.clientX;
            pos2 = pos4 - e.clientY;
            pos3 = e.clientX;
            pos4 = e.clientY;
            // set the element's new position:
            elmnt.style.top = (elmnt.offsetTop - pos2) + "px";
            elmnt.style.left = (elmnt.offsetLeft - pos1) + "px";
        }

        function closeDragElement() {
            // stop moving when mouse button is released:
            document.onmouseup = null;
            document.onmousemove = null;
            if(pos3 - startX < 5 && pos3-startX > -5 && pos4 - startY < 5 && pos4-startY > -5) return;
            let crosshair = document.querySelector('#xpath-generator-selector-img').getBoundingClientRect();
            let x = parseInt(crosshair.left + crosshair.width/2);
            let y = parseInt(crosshair.top + crosshair.height/2);

            var elementsAtPoint = document.elementsFromPoint(x, y);
            var xPathBuilder = new XPathBuilder(elementsAtPoint[4]);
            document.getElementById('xpath').value = xPathBuilder.xPath;
            /*
            var matches = getElementsByXPath(xPathBuilder.xPath);
            for(var i = 0; i < matches.length; i++){
                matches[i].classList.add('highlight-xpath-match');
                setTimeout(function(){
                    this.classList.remove('highlight-xpath-match');
                }.bind(matches[i]), 500);
            }
            */
            updateStatus();
        }
    }
}
